<template>
  <v-card class="pt-4">
    <v-card-text>
      <v-form ref="form" @submit.prevent="validarFormulario">
        <v-select
          v-model="formHistoriaClinica.tipo"
          :items="items"
          label="Tipo"
          :rules="rules.nombre"
          required
          color="accent"
          autofocus
        />
        <v-row>
          <v-col :cols="$vuetify.breakpoint.smAndDown ? '12':'6'">
            <v-text-field
              v-model="nombreClienteFinal"
              disabled
              label="Cliente"
              type="text"
              required
              color="accent"
            />
          </v-col>
          <v-col>
            <v-btn
              color="accent"
              @click="dialogListaCliente=true"
            >
              Seleccionar cliente
            </v-btn>
            <v-btn
              v-if="!cliente"
              color="secondary"
              icon
              :class="$vuetify.breakpoint.smAndDown ? '' : 'ma-2'"
              @click="dialogCliente = true"
            >
              <v-icon
                right
                dark
              >
                fas fa-user-plus
              </v-icon>
            </v-btn>
          </v-col>
        </v-row>
        <v-row>
          <v-col :cols="$vuetify.breakpoint.smAndDown ? '12':'6'">
            <v-text-field
              v-model="nombreMascotaFinal"
              disabled
              label="Mascota"
              type="text"
              required
              color="accent"
            />
          </v-col>
          <v-col>
            <v-tooltip bottom>
              <template #activator="{ on, attrs }">
                <v-btn
                  color="accent"
                  v-bind="attrs"
                  @click="clienteActual ? dialogListaMascota=true : dialogMascota = false"
                  v-on="clienteActual ? '' : on"
                >
                  Seleccionar mascota
                </v-btn>
              </template>
              <span>Seleccione un cliente para continuar</span>
            </v-tooltip>
            <v-tooltip v-if="!mascota" bottom>
              <template #activator="{ on, attrs }">
                <v-btn
                  color="secondary"
                  v-bind="attrs"
                  icon
                  :class="$vuetify.breakpoint.smAndDown ? '' : 'ma-2'"
                  @click="clienteActual ? dialogMascota = true : dialogMascota = false"
                  v-on="on"
                >
                  <v-icon
                    right
                    dark
                  >
                    fas fa-user-plus
                  </v-icon>
                </v-btn>
              </template>
              <span>Seleccione un cliente para continuar</span>
            </v-tooltip>
          </v-col>
        </v-row>
        <v-row>
          <v-col :cols="$vuetify.breakpoint.smAndDown ? '12':'6'">
            <v-text-field
              v-model="nombreVeterinarioFinal"
              disabled
              label="Veterinario"
              type="text"
              required
              color="accent"
            />
          </v-col>
          <v-col>
            <v-btn
              color="accent"
              @click="dialogListaVeterinario=true"
            >
              Seleccionar veterinario
            </v-btn>
            <v-btn
              v-if="!veterinario"
              color="secondary"
              icon
              :class="$vuetify.breakpoint.smAndDown ? '' : 'ma-2'"
              @click="dialogVeterinario = true"
            >
              <v-icon
                right
                dark
              >
                fas fa-user-plus
              </v-icon>
            </v-btn>
          </v-col>
        </v-row>
        <v-textarea
          v-model="formHistoriaClinica.observaciones"
          outlined
          :rules="rules.required"
          color="accent"
          label="Observaciones"
        />
      </v-form>
    </v-card-text>
    <v-card-actions :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
      <v-btn class="elevation-2 font-weight-light" @click="cerrarDialog()">
        Cerrar
      </v-btn>
      <v-spacer />
      <v-btn v-if="!isEditar" class="elevation-2 font-weight-light accent" @click="validarFormulario">
        Agregar
      </v-btn>
      <v-btn v-else class="elevation-2 font-weight-light accent" @click="validarFormulario">
        Modificar
      </v-btn>
    </v-card-actions>

    <v-dialog v-model="dialogListaCliente" width="1400" :fullscreen="$vuetify.breakpoint.smAndDown">
      <v-card v-if="dialogListaCliente">
        <v-card-text :class="$vuetify.breakpoint.smAndDown ? 'dialog-content-scrollerd-unico' : 'dialog-content-scrollerd'">
          <lista-clientes :seleccionable="true" :cliente-seleccionado="clienteActual" @selectedCliente="actualizarCliente" />
        </v-card-text>
        <v-card-actions :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
          <v-btn class="elevation-2 font-weight-light" @click="dialogListaCliente = false">
            Cerrar
          </v-btn>
          <v-spacer />
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog v-model="dialogListaMascota" width="1400" :fullscreen="$vuetify.breakpoint.smAndDown">
      <v-card>
        <v-card-text :class="$vuetify.breakpoint.smAndDown ? 'dialog-content-scrollerd-unico' : 'dialog-content-scrollerd'">
          <lista-mascotas
            v-if="dialogListaMascota"
            :seleccionable="true"
            :cliente-actual="clienteActual"
            :mascota-seleccionado="mascotaActual"
            @onEdit="editarForm"
            @selectedMascota="actualizarMascota"
          />
        </v-card-text>
        <v-card-actions :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
          <v-btn class="elevation-2 font-weight-light" @click="dialogListaMascota = false">
            Cerrar
          </v-btn>
          <v-spacer />
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog v-model="dialogListaVeterinario" width="1400" :fullscreen="$vuetify.breakpoint.smAndDown">
      <v-card>
        <v-card-text :class="$vuetify.breakpoint.smAndDown ? 'dialog-content-scrollerd-unico' : 'dialog-content-scrollerd'">
          <lista-veterinarios v-if="dialogListaVeterinario" :seleccionable="true" :veterinario-seleccionado="veterinarioActual" @selectedVeterinario="actualizarVeterinario" />
        </v-card-text>
        <v-card-actions :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
          <v-btn class="elevation-2 font-weight-light" @click="dialogListaVeterinario = false">
            Cerrar
          </v-btn>
          <v-spacer />
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog v-model="dialogCliente" width="500" :fullscreen="$vuetify.breakpoint.smAndDown">
      <form-clientes v-if="dialogCliente" :form-desde-ventas="true" @onClose="dialogCliente = false" @addedCliente="actualizarCliente" />
    </v-dialog>
    <v-dialog v-model="dialogVeterinario" width="800" :fullscreen="$vuetify.breakpoint.smAndDown">
      <form-veterinarios v-if="dialogVeterinario" @onClose="dialogVeterinario = false" @addedVeterinario="actualizarVeterinario" />
    </v-dialog>
    <v-dialog v-model="dialogMascota" width="800" :fullscreen="$vuetify.breakpoint.smAndDown">
      <form-mascotas v-if="dialogMascota" :cliente-actual="clienteActual" :mascota="mascotaActual" @onClose="dialogMascota = false" @addedMascota="actualizarMascota" />
    </v-dialog>
  </v-card>
</template>

<script lang="ts">
import { Component, Prop, Ref, Vue } from 'vue-property-decorator'
import { Cliente } from '~/core/models/cliente'
import { ClientesStore } from '~/store/ClientesStore'
import { Veterinario } from '~/core/models/veterinario'
import { VeterinariosStore } from '~/store/VeterinariosStore'
import { HistoriaClinica } from '~/core/models/historiaClinica'
import AppToast from '~/core/utils/AppToast'
import { AppStore } from '~/store/AppStore'
import { HistoriasClinicasStore } from '~/store/HistoriasClinicasStore'
import ListaVeterinarios from '~/components/veterinarios/listaVeterinarios.vue'
import FormVeterinarios from '~/components/veterinarios/formVeterinarios.vue'
import FormClientes from '~/components/clientes/formClientes.vue'
import ListaClientes from '~/components/clientes/listaClientes.vue'
import ListaMascotas from '~/components/mascotas/listaMascotas.vue'
import { Mascota } from '~/core/models/mascota'
import { MascotasStore } from '~/store/MascotasStore'
import FormMascotas from '~/components/mascotas/formMascotas.vue'

@Component({
  components: { FormMascotas, ListaMascotas, ListaVeterinarios, FormVeterinarios, FormClientes, ListaClientes }
})
export default class formHistoriasClinicas extends Vue {
  @Ref('form') formulario;
  @Prop({ default: null }) historiaclinica!:HistoriaClinica;

  clienteActual:Cliente = null;
  dialogListaCliente:boolean =false;
  dialogCliente:boolean = false;
  mascotaActual:Mascota = null;
  dialogListaMascota:boolean =false;
  dialogMascota:boolean = false;
  veterinarioActual:Veterinario = null;
  dialogListaVeterinario:boolean =false;
  dialogVeterinario:boolean = false;

  items= ['Vacunación', 'Operación', 'Consulta']

  formHistoriaClinica:HistoriaClinica = {
    clientes_idclientes: null,
    veterinarios_idveterinarios: null,
    mascotas_idmascotas: null,
    tipo: null,
    observaciones: ''
  }

  rules = {
    required: [
      v => !!v || 'Campo requerido'
    ]
  };

  get nombreClienteFinal ():string {
    return this.cliente ? this.cliente.nombre : 'Por favor seleccione un cliente'
  }

  get cliente ():Cliente {
    return this.formHistoriaClinica.clientes_idclientes && ClientesStore.listaClientes.find(p => p.idclientes === this.formHistoriaClinica.clientes_idclientes)
  }

  get nombreVeterinarioFinal ():string {
    return this.veterinario ? this.veterinario.name : 'Por favor seleccione un veterinario'
  }

  get veterinario ():Veterinario {
    return this.formHistoriaClinica.veterinarios_idveterinarios && VeterinariosStore.listaVeterinarios.find(p => p.idveterinarios === this.formHistoriaClinica.veterinarios_idveterinarios)
  }

  get nombreMascotaFinal ():string {
    return this.mascota ? this.mascota.nombre : 'Por favor seleccione una mascota'
  }

  get mascota ():Mascota {
    return this.formHistoriaClinica.mascotas_idmascotas && MascotasStore.mascotas.find(p => p.idmascotas === this.formHistoriaClinica.mascotas_idmascotas)
  }

  editarForm (val) {
    this.mascotaActual = val
    this.dialogMascota = true
  }

  actualizarCliente (cliente:Cliente) {
    if (cliente) {
      this.clienteActual = cliente
      this.formHistoriaClinica.clientes_idclientes = cliente.idclientes
      this.actualizarMascota(null)
    } else {
      this.clienteActual = null
      this.formHistoriaClinica.clientes_idclientes = null
      this.actualizarMascota(null)
    }
    this.dialogListaCliente = false
  }

  actualizarVeterinario (veterinario:Veterinario) {
    if (veterinario) {
      this.veterinarioActual = veterinario
      this.formHistoriaClinica.veterinarios_idveterinarios = veterinario.idveterinarios
    } else {
      this.veterinarioActual = null
      this.formHistoriaClinica.veterinarios_idveterinarios = null
    }
    this.dialogListaVeterinario = false
  }

  actualizarMascota (mascota:Mascota) {
    if (mascota) {
      this.mascotaActual = mascota
      this.formHistoriaClinica.mascotas_idmascotas = mascota.idmascotas
    } else {
      this.mascotaActual = null
      this.formHistoriaClinica.mascotas_idmascotas = null
    }
    this.dialogListaMascota = false
  }

  get isEditar () {
    return this.historiaclinica
  }

  mounted () {
    if (this.isEditar) {
      this.cargarFormConHistoriaClinica()
    }
  }

  private cargarFormConHistoriaClinica () {
    Object.assign(
      this.formHistoriaClinica,
      this.historiaclinica
    )
  }

  validarFormulario () {
    if (this.clienteActual && this.mascotaActual && this.veterinarioActual) {
      if (this.formulario.validate()) {
        if (this.isEditar) {
          this.modificar()
        } else if (this.formHistoriaClinica.tipo === 'Vacunación' || this.formHistoriaClinica.tipo === 'Consulta') {
          this.dialogVentas()
          this.guardar()
        } else {
          this.guardar()
        }
      } else {
        AppToast.error('Campos inválidos')
      }
    } else {
      AppToast.error('Por favor seleccine los datos para continuar')
    }
  }

  dialogVentas () {
    this.$confirm('¿Desea vender?').then(async (res) => {
      if (res) {
        await this.$router.push('/ventas')
      }
    }).catch()
  }

  private async guardar () {
    AppStore.SHOW_LOADING('Guardando Historia Clínica')
    try {
      await HistoriasClinicasStore.registrarHistoriaClinica(this.formHistoriaClinica)
      this.cerrarDialog()
      AppToast.success(' Historia Clínica registrada')
    } catch (e) {
    }
    AppStore.HIDE_LOADING()
  }

  private async modificar () {
    AppStore.SHOW_LOADING('Guardando  Historia Clínica')
    try {
      await HistoriasClinicasStore.modificarHistoriaClinica(this.formHistoriaClinica)
      this.cerrarDialog()
      AppToast.success(' Historia Clínica registrada')
    } catch (e) {
    }
    AppStore.HIDE_LOADING()
  }

  cerrarDialog () {
    this.$emit('onClose')
  }
}
</script>

<style lang="scss">

</style>
